SystemOrganization addCategory: #'GT-SUnitDebugger'!

DebugSession subclass: #GTSUnitDebugSession
	instanceVariableNames: 'assertionContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitDebugSession class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:24'!
activationPredicate

	^  GTSUnitActivationPredicate new! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:35'!
actualResult
	
	^ assertionContext tempAt: 1! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:35'!
expectedResult
	
	^ assertionContext tempAt: 2! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:25'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	assertionContext ifNil: [
		assertionContext := aContext findContextMatchingPredicate: self class activationPredicate]! !

!GTSUnitDebugSession methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 13:02'!
testContext

	^ assertionContext sender! !

ContextPredicate subclass: #GTSUnitActivationPredicate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitActivationPredicate methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:19'!
matchContext: aContext
	
	^ aContext selector == #assert:equals:! !

GTDebugger subclass: #GTSUnitDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTSUnitDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/4/2013 12:07'!
defaultTitle

	^ 'SUnit Debugger'! !

!GTSUnitDebugger class methodsFor: 'testing' stamp: 'AndreiChis 12/4/2013 12:33'!
handlesContext: aContext
	self flag: 'this should go to the superclass'.
	^ (aContext findContextMatchingPredicate: self sessionClass activationPredicate) notNil! !

!GTSUnitDebugger class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:14'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 70.! !

!GTSUnitDebugger class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 12:14'!
sessionClass

	^ GTSUnitDebugSession! !

!GTSUnitDebugger methodsFor: 'building' stamp: 'TudorGirba 12/14/2013 11:14'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack;
						column: #code span: 2 ];
		row: #diff.! !

!GTSUnitDebugger methodsFor: 'building' stamp: 'TudorGirba 12/13/2013 22:46'!
debuggerTransmissionsIn: browser

	browser transmit
		fromOutsideEntityPort;
		to: #stack;
		andShow: [ :composite | self stackIn: composite ].
	browser transmit
		from: #stack port: #entity;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session context].
	browser transmit
		fromOutsideEntityPort;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session testContext].
	browser transmit
		from: #stack port: #selection;
		to: #code;
		andShow: [ :composite :aContext | self methodCodeIn: composite forContext: aContext ].
	browser transmit
		from: #stack port: #selection;
		to: #diff;
		andShow: [ :composite | 
			(self diffIn: composite) title: 'Actual vs. expected'.
			(self inspectorIn: composite) title: 'Inspector' ] 
! !

!GTSUnitDebugger methodsFor: 'building presentations' stamp: 'TudorGirba 12/13/2013 22:49'!
diffIn: composite

	^ composite diff
			display: [ { 
				self printCollection: self session actualResult asOrderedCollection. 
				self printCollection: self session expectedResult asOrderedCollection }]! !

!GTSUnitDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 17:37'!
printCollection: aCollection

	 ^ String streamContents: [ :out | 
			aCollection do: [ :each | 
				out 
					nextPutAll: each printString;
					nextPut: Character cr ]]! !

TestCase subclass: #GTFailingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SUnitDebugger'!

!GTFailingTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/5/2013 12:46'!
expectedFailures

	^ #(testCompleteSentence testFail testFailingDate testMultiValuedStreaming)! !

!GTFailingTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 16:30'!
testCompleteSentence
	
	self
		assert:
			(MalCamelcaseScanner scan: 'TheNextBIGThing isKindOf: Hype, VeryBIG BIG')
		equals:
			#('the' 'next' 'gIG' 'thing' 'is' 'kind' 'of' 'hype' 'very' 'bIG' 'bIG') asBag.! !

!GTFailingTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 13:57'!
testFail

	self assert: 'I like pie  
pizza pie 
apple pie 
rad squared pi 
and other PIes'
	equals: 'I like pie  
pizza pie 
potato pie 
rad squared pi 
and other PIes'! !

!GTFailingTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 11:19'!
testFailingDate
	|aDateAndTime|
	
	aDateAndTime :=  DateAndTime localTimeZone: TimeZone default; dosEpoch.
	self assert: (aDateAndTime offset: '0:12:00:00')  equals: '1980-01-01T13:00:00+12:00' asDateAndTime! !

!GTFailingTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/4/2013 17:41'!
testMultiValuedStreaming
	| headers keysAndValues |
	headers := ZnHeaders new.
	headers at: 'Set-Cookie' put: 'foo=1'.
	headers at: 'Set-Cookie' add: 'bar=1'.
	headers at: 'Content-TYPE' put: 'text/plain'.
	headers at: 'Content-Length' put: '128'.
	keysAndValues := OrderedCollection streamContents: [ : stream |
		headers headersDo: [ :key :value |
			stream nextPut: key; nextPut: value ] ].
	self assert: keysAndValues equals: #('Set-Cookie' 'foo=1' 'Set-Cookie' 'bar=1' 'Content-Length' '128' 'Content-TYPE' 'text/plain') asOrderedCollection 
	
	! !
